//+------------------------------------------------------------------+
//|                                                              rsx |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "copyleft mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers    5
#property indicator_color1     DarkSlateGray
#property indicator_color2     DarkSlateGray
#property indicator_color3     Green
#property indicator_color4     Red
#property indicator_color5     Red
#property indicator_levelcolor DarkSlateGray
#property indicator_style1     STYLE_DOT
#property indicator_style2     STYLE_DOT

//
//
//
//
//

extern int  Length               = 14;
extern int  Price                = 0;
extern bool Double               = false;
extern bool ShowHistogram        = true;
extern bool ShowUpDownLimit      = false;
extern bool PreFilterPrice       = true;
extern int  PreFilterPriceLength = 5;

//
//
//
//
//

double rsx[];
double rsxU[];
double rsxD[];
double limU[];
double limD[];
double stored[][26];

//
//
//
//
//

int    Correction = 0;
int    LoopCount  = 1;
double smoothCoeffs[];
double smoothDivisor;


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

#define Pi 3.141592653589793238462643
int init()
{
   SetIndexBuffer(0,limU); SetIndexLabel(0,NULL);
   SetIndexBuffer(1,limD); SetIndexLabel(1,NULL);
   SetIndexBuffer(4,rsx);  SetIndexLabel(4,"RSX");
   if (ShowHistogram)
   {
      SetIndexBuffer(2,rsxU); SetIndexStyle(2,DRAW_HISTOGRAM); SetIndexLabel(2,"RSX");
      SetIndexBuffer(3,rsxD); SetIndexStyle(3,DRAW_HISTOGRAM); SetIndexLabel(3,"RSX");
      Correction = -50;
   }
   else
   {
      SetIndexStyle(2,DRAW_NONE); SetIndexLabel(2,NULL);
      SetIndexStyle(3,DRAW_NONE); SetIndexLabel(3,NULL);
   }
   if (Double) LoopCount = 2;
   
   //
   //
   //
   //
   //
   
   ArrayResize(smoothCoeffs, PreFilterPriceLength);
      smoothCoeffs[0] = 1;
      smoothDivisor   = 1;
      for (int i = 1; i < PreFilterPriceLength; i++)
      {
         double temp = 1 << i / Pi;
            smoothCoeffs[i] = MathSin(temp) / temp;
            smoothDivisor  += smoothCoeffs[i];
      }

   //
   //
   //
   //
   //
      
   IndicatorShortName("Rsx ("+Length+")");
   return(0);
}
int deinit() { return(0); }




//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,r,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = Bars-counted_bars;
         if (ArrayRange(stored,0) != Bars) ArrayResize(stored,Bars);

   //
   //
   //
   //
   //
   
   for(i=limit, r=Bars-i-1; i>=0; i--, r++)
   {
      if (!PreFilterPrice) double trsx = iMA(NULL,0,1,0,MODE_SMA,Price,i);
      else  
         {
            double sum = 0;
            for (int l = 0; l < PreFilterPriceLength; l++) sum += iMA(NULL,0,1,0,MODE_SMA,Price,l+i)*smoothCoeffs[l];
                  trsx = (sum/smoothDivisor);
         }                  
      
      //
      //
      //
      //
      //
      
      for (int k=0; k<LoopCount; k++)
      {
         stored[r][24+k] = trsx;
            double roc   = trsx-stored[r-1][24+k];
            double roa   = MathAbs(roc);
            double avg1  = iCalc(roc,Length,i,r,k*12);
            double avg2  = iCalc(roa,Length,i,r,k*12+6);

            //
            //
            //
            //
            //
               
            if (avg2 != 0)
                 trsx = MathMax(MathMin((avg1/avg2+1.0)*50.0,100.00),0.00); 
            else trsx = 50.0;
      }            
      rsx[i] = trsx+Correction;

      //
      //
      //
      //
      //
               
      if (ShowHistogram)
      {
         rsxD[i] = rsxD[i+1];
         rsxU[i] = rsxU[i+1];
            if (rsx[i] > rsx[i+1]) { rsxU[i] = rsx[i];  rsxD[i] = EMPTY_VALUE; }
            if (rsx[i] < rsx[i+1]) { rsxD[i] = rsx[i];  rsxU[i] = EMPTY_VALUE; }
      }
      if (ShowUpDownLimit)
      {
         limD[i] = Correction;
         limU[i] = Correction+100;
      }         
   }     
   
   //
   //
   //
   //
   //
       
   return(0);
}




//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

#define F01 0
#define F02 1
#define F03 2
#define F04 3
#define F05 4
#define F06 5

//
//
//
//
//

double iCalc(double price, int period, int i, int r, int s)
{
   double f01=stored[r-1][s+F01];  double f02=stored[r-1][s+F02];
   double f03=stored[r-1][s+F03];  double f04=stored[r-1][s+F04];
   double f05=stored[r-1][s+F05];  double f06=stored[r-1][s+F06];

   //
   //
   //
   //
   //

      double Kg = 3.0/(2.0+period);
      double Hg = 1.0-Kg;

      f01 = Kg * price + Hg * f01; f02 = Kg * f01 + Hg * f02; double v01 = 1.5 * f01 - 0.5 * f02;
      f03 = Kg * v01   + Hg * f03; f04 = Kg * f03 + Hg * f04; double v02 = 1.5 * f03 - 0.5 * f04;
      f05 = Kg * v02   + Hg * f05; f06 = Kg * f05 + Hg * f06; double v03 = 1.5 * f05 - 0.5 * f06;

   //
   //
   //
   //
   //

   stored[r][s+F01] = f01;  stored[r][s+F02] = f02;
   stored[r][s+F03] = f03;  stored[r][s+F04] = f04;
   stored[r][s+F05] = f05;  stored[r][s+F06] = f06;
   return(v03);
}